diff -Naur --exclude=CVS --exclude=configs linux/hpc/remote.c linux-openmosix/hpc/remote.c
--- linux/hpc/remote.c	1970-01-01 01:00:00.000000000 +0100
+++ linux-openmosix/hpc/remote.c	2004-02-05 02:48:27.000000000 +0100
@@ -0,0 +1,1451 @@
+/* Changes since Feb 12, 2002 by Moshe Bar
+ * Copyright (C) 2000, 2001, Amnon Barak (amnon@cs.huji.ac.il)
+ *
+ * Permission to use this software is hereby granted under the terms of the
+ * GNU General Public License, as published by the Free Software Foundation.
+ *
+ * Author(s): Amnon Shiloh, Moshe Bar
+ */
+
+
+#include <linux/sched.h>
+#include <linux/string.h>
+#include <linux/hpc.h>
+#include <linux/personality.h>
+#include <hpc/protocol.h>
+#include <hpc/comm.h>
+#include <hpc/routines.h>
+#include <hpc/defs.h>
+#include <hpc/debug.h>
+#include <asm/processor.h>
+#include <linux/smp_lock.h>
+#include <linux/mm.h>
+#include <linux/pagemap.h>
+#include <asm/uaccess.h>
+#include <linux/in6.h>
+#include <asm/checksum.h>
+#include <linux/slab.h>
+#include <linux/elf.h>
+#include <asm/mman.h>
+#include <linux/unistd.h>
+#include <linux/module.h>
+#include <linux/file.h>
+#include <hpc/balance.h>
+#include <hpc/dfsa.h>
+
+int
+remote_wait(int expect, void **head, int *hlen)
+{
+	int type, error = 0;
+	register struct task_struct *p = current;
+	struct syscall_ret_h *rp;
+	unsigned int has_ret_value = 0;
+	int ret_value = 0;	/* value set only to pacify compiler */
+
+	while(1)
+	{
+		if(URGENT_REMOTE_CONDITIONS(p) &&
+					!(p->mosix.dflags & DSENTURGENT))
+			inform_deputy_of_urgent();
+		if((type = comm_recv(head, hlen)) < 0)	/* an error */
+			return(type);
+		if(expect == DEP_USERMODE)
+		/* after migration from REMOTE to REMOTE, certain "replies"
+		 * can arrive as a result from the original call.
+		 * Fortunately, there are not too many of them:
+		 */
+			switch(type & ~USERMODE)
+			{
+			case REM_SYSCALL|REPLY:
+				rp = *head;
+				absorb_deptime(rp->deputytime);
+				remote_unpack_read_cache_data(rp);
+				has_ret_value = 1;
+				ret_value = rp->ret;
+				/* fall through */
+			case REM_SYSCALL_TRACE|REPLY:
+				if(!(type & USERMODE))
+				{
+					comm_free(*head);
+					*head = NULL;
+					continue;
+				}
+			}
+		if(type & USERMODE)
+		{
+			p->mosix.dflags &= ~DPSYNC;
+			if(expect == DEP_USERMODE)
+			{
+				if(has_ret_value)
+					mos_to_regs(&p->mosix)->eax = ret_value;
+				return(0);
+			}
+			if(type != (expect | USERMODE))
+			{
+				printk("REMOTE-%d: Unexected USERMODE while waiting for 0x%x\n",
+					p->pid, expect);
+				mosix_panic("Unexpected USERMODE");
+				return(-EINVAL);
+			}
+		}
+		if((type & ~USERMODE) == expect)
+			return(0);
+		switch(type & ~USERMODE)
+		{
+		case DEP_SYNC:
+			comm_free(*head);
+			break;
+		case DEP_NOTHING:
+			comm_free(*head);
+			error = comm_send(DEP_NOTHING|REPLY, NULL, 0,
+					  NULL, 0, 0);
+			break;
+		case DEP_MMAP:
+			error = remote_mmap((struct mmap_parameters_h *)*head, 0);
+			break;
+		case DEP_BRK:
+			error = remote_brk((struct brk_parameters_h *)*head);
+			break;
+		case DEP_MUNMAP:
+			error = remote_munmap((struct munmap_parameters_h *)*head);
+			break;
+		case DEP_MPROTECT:
+			error = remote_mprotect((struct mprotect_parameters_h *)*head);
+			break;
+		case DEP_LISTHOLD:
+			comm_free(*head);
+			error = remote_report_files();
+			break;
+		case DEP_SETUPFRAME:
+			error = remote_setup_frame((struct setupframe_parameters_h *)*head);
+			break;
+		case DEP_NICE:
+			error = remote_nice((long *)*head);
+			break;
+		case DEP_INFO:
+			error = remote_updinfo((struct disclosure_h *)*head);
+			break;
+		case DEP_CAPS:
+			error = remote_caps((kernel_cap_t *)*head);
+			break;
+		case DEP_OPCOSTS:
+			error = remote_depcosts(*head);
+			break;
+		case DEP_RESTORESIGCONTEXT:
+			error = remote_restore_sigcontext((struct sigcontext **)*head);
+			break;
+		case DEP_PREQUEST:
+			error = remote_prequest((struct prequest_h *)*head);
+			break;
+		case DEP_COPY_FROM_USER:
+			error = remote_copy_from_user((struct user_copy_h *)*head);
+			break;
+		case DEP_COPY_TO_USER:
+			error = remote_copy_to_user((struct user_copy_h *)*head);
+			break;
+		case DEP_DATA_TO_USER:
+			error = remote_data_to_user((struct user_copy_h *)*head);
+			break;
+		case DEP_CLEAR_USER:
+			error = remote_clear_user((struct user_copy_h *)*head);
+			break;
+		case DEP_STRNCPY_FROM_USER:
+			error = remote_strncpy_from_user((struct user_copy_h *)*head);
+			break;
+		case DEP_STRNLEN_USER:
+			error = remote_strnlen_user((struct strnlen_user_h *)*head);
+			break;
+		case DEP_VERIFY_WRITE:
+			error = remote_verify_write((struct user_copy_h *)*head);
+			break;
+		case DEP_CSUM_COPY_FROM_USER:
+			error = remote_csum_copy_from_user((struct user_csum_copy_h *)*head);
+			break;
+		case DEP_CACHE_READ_DATA:
+			error = remote_unpack_read_cache_data(NULL);
+			/* NO REPLY! */
+			break;
+		case DEP_RLIMIT:
+			error = remote_rlimit((struct rlimit_h *)*head);
+			break;
+		case DEP_TAKEURGENT:
+			comm_free(*head);
+			error = remote_urgent();
+			break;
+		case DEP_RUSAGE:
+			error = remote_rusage((int *)*head);
+			break;
+		case DEP_PERSONALITY:
+			error = remote_personality((unsigned long *)*head);
+			break;
+		case DEP_EXECVE_COUNTS:
+			error = remote_execve_counts((struct execve_counts_h *)*head);
+			break;
+		case DEP_BRING_STRINGS:
+			error = remote_bring_strings((struct execve_bring_strings_h *)*head);
+			break;
+		case DEP_SETUP_ARGS:
+			error = remote_setup_args((struct execve_setup_args_h *)*head);
+			break;
+		case DEP_EXEC_MMAP:
+			error = remote_exec_mmap();
+			break;
+		case DEP_INIT_AOUT_MM:
+			error = remote_init_aout_mm((struct exec *)*head);
+			break;
+		case DEP_ELF_SETUP:
+			error = remote_elf_setup((struct execve_elf_setup_h *)*head);
+			break;
+		case DEP_FIX_ELF_AOUT:
+			error = remote_fix_elf_aout((struct execve_fix_elf_aout_h *)*head);
+			break;
+		case DEP_DUMP_THREAD:
+			/* comm_free(*head); is not needed (NULL) */
+			error = remote_dump_thread();
+			break;
+		case DEP_LIST_VMAS:
+			/* comm_free(*head); is not needed (NULL) */
+			error = remote_list_vmas();
+			break;
+		case DEP_PLEASE_FORK:
+			error = remote_fork((struct fork_h *)*head);
+			break;
+		case DEP_BRING_ME_REGS:
+			error = remote_bring_me_regs((unsigned long *)*head);
+			break;
+		case DEP_DUMP_FPU:
+			/* comm_free(*head); is not needed (NULL) */
+			error = remote_dump_fpu();
+			break;
+		case DEP_COME_BACK:
+			if (!remote_come_back(*head) || bootexpel)
+				remote_disappear();
+			break;
+		case DEP_PLEASE_MIGRATE:
+			error = remote_goto_remote(*head);
+			break;
+		case DEP_CONSIDER:
+			error = remote_consider((int *)*head);
+			break;
+		case DEP_UPDATE_DECAY:
+			error = remote_setdecay((struct decay_h *)*head);
+			break;
+		case DEP_UPDATE_LOCK:
+			error = remote_set_lock((int *)*head);
+			break;
+		case DEP_UPDATE_MIGFILTER:
+			error = remote_set_migfilter((int *)*head);
+			break;
+		case DEP_UPDATE_MIGPOLICY:
+			error = remote_set_migpolicy((int *)*head);
+			break;
+		case DEP_UPDATE_MIGNODES:
+			error = remote_set_mignodes((int *)*head);
+			break;
+		case DEP_PSINFO:
+			/* comm_free(*head); is not needed (NULL) */
+			error = remote_psinfo();
+			break;
+#ifdef CONFIG_MOSIX_DFSA
+		case DEP_DFSA_CLEAR:
+			remote_clear_dfsa();
+			error = comm_send(DEP_DFSA_CLEAR|REPLY, NULL, 0,
+					  NULL, 0, 0);
+			break;
+		case DEP_DFSA_CHANGES:
+			error = remote_receive_dfsachanges((int *)*head);
+			break;
+		case DEP_READ_YOURSELF:
+			error = remote_read_yourself(
+				(struct read_yourself_h *)*head);
+			break;
+#endif /* CONFIG_MOSIX_DFSA */
+		default:
+			printk("openMosix: remote type %x unexpected\n", type);
+
+			if(type != MIG_REQUEST)
+				mosix_panic("deputy_wait");
+			return(-EINVAL);
+		}
+		if(error)
+		{
+			return(error);
+		}
+	}
+}
+
+int
+remote_request(int type, void *header, int hlen, void *data, int dlen,
+	int uspace, void **result, int reslen)
+{
+	void *head;
+	int rhlen;
+	int error;
+
+	if((error = comm_send(type, header, hlen, data, dlen, uspace)))
+		return(error);
+	if((error = remote_wait(type|REPLY, &head, &rhlen)))
+		return(error);
+	if(reslen > 0)
+	{
+		if(rhlen > reslen)
+			goto lenerr;
+		if(result)
+			*result = head;
+	}
+	else
+	{
+		if(rhlen > -reslen)
+		{
+			comm_free(head);
+			lenerr:
+			printk("remote_request type %x: %d instead of %d\n",
+				type, rhlen, reslen);
+			return(-EDIST);
+		}
+		if(reslen)
+			memcpy(result, head, rhlen);
+		comm_free(head);
+	}
+	return(error);
+}
+
+int
+remote_deputy_has_something_for_us(struct task_struct *p)
+{
+	return((p->mosix.dflags & DPSYNC) || comm_peek());
+}
+
+void
+wait_for_permission_to_continue()
+{
+	struct task_struct *p = current;
+	void *head;
+	int hlen;
+
+	if(!p->mosix.contact)
+	{
+		DECLARE_WAITQUEUE(wait, current);
+
+		add_wait_queue(mos_to_waitp(&p->mosix), &wait);
+		set_current_state(TASK_UNINTERRUPTIBLE);
+		while(!p->mosix.contact)
+		{
+			set_current_state(TASK_UNINTERRUPTIBLE);
+			if(p->mosix.contact)
+				break;
+			schedule();
+		}
+		remove_wait_queue(mos_to_waitp(&p->mosix), &wait);
+		set_current_state(TASK_RUNNING);
+	}
+	if(!(p->mosix.dflags & DPSYNC))
+	{
+		if(!comm_peek())
+			return;
+		if(URGENT_REMOTE_CONDITIONS(p) &&
+					!(p->mosix.dflags & DSENTURGENT))
+			inform_deputy_of_urgent();
+		if(comm_send(REM_NULLMSG, NULL, 0, NULL, 0, 0))
+			remote_disappear();
+	}
+	if(remote_wait(DEP_USERMODE, &head, &hlen))
+		remote_disappear();
+	comm_free(head);
+	if(p->mosix.deputy_regs)
+	{
+		printk("%s: Missing registers on User-Mode",desc_mostask(NULL));
+		mosix_panic("missing regs");
+		remote_disappear();
+	}
+}
+
+void
+inform_deputy_of_urgent(void)
+{
+	struct mosix_task *m = &current->mosix;
+
+	if(m->dflags & (DPASSING|DINCOMING))
+		return;
+
+	spin_lock_irq(&runqueue_lock);
+	m->dflags |= DSENTURGENT;
+	spin_unlock_irq(&runqueue_lock);
+	comm_send_urgent();
+	/* (any errors will be detected by a later communication failure) */
+}
+
+void
+transfer_signals_to_deputy(unsigned int sigs, siginfo_t *info, int ninfo)
+{
+	struct asig_h a;
+
+	a.sigs = sigs;
+	a.nforced = ninfo;
+	comm_send(REM_ASIG, &a, sizeof(a), info, ninfo * sizeof(siginfo_t), 0);
+}
+
+NORET_TYPE void
+remote_disappear(void)
+{
+	do_exit(SIGKILL);
+	/*NOTREACHED*/
+}
+
+long
+remote_standard_system_call(int n, struct pt_regs *regs)
+{
+	struct syscall_h s;
+	struct syscall_ret_h r;
+	char *p, *tofree;
+	int l;
+	int data_from_user;
+	void *head;
+	int rhlen;
+	int error;
+
+	s.n = n;
+	memcpy((caddr_t)s.args, (caddr_t)regs, sizeof(s.args));
+	switch(n)
+	{
+		/* the following system-calls are supposed to ask for the
+		 * following registers - but why wait for them to ask?
+		 */
+	case __NR_fork:
+	case __NR_vfork:
+	case __NR_clone:
+	case __NR_sigaltstack:
+		current->mosix.pass_regs |= BIT_OF_REGISTER(esp);
+		break;
+	case __NR_execve:
+		current->mosix.pass_regs |= BIT_OF_REGISTER(edx);
+		break;
+	case __NR_sigsuspend:
+	case __NR_rt_sigsuspend:
+		current->mosix.pass_regs |= BIT_OF_REGISTER(orig_eax) |
+			BIT_OF_REGISTER(eax) | BIT_OF_REGISTER(eip);
+		break;
+	case __NR_sigreturn:
+	case __NR_rt_sigreturn:
+		current->mosix.pass_regs = ALL_REGISTERS;
+		break;
+	}
+	p = construct_ucache_envelope(&l, &data_from_user, &s, &tofree);
+	bump_syscalls();
+	if(p)
+		bump_copyin(l);
+	/* Cannot use "remote_request" here, because we MUST free "tofree" */
+	error = comm_send(REM_SYSCALL, &s, sizeof(s), p, l, data_from_user);
+	if(tofree)
+		kfree(tofree);
+	if(error || remote_wait(REM_SYSCALL|REPLY, &head, &rhlen))
+		remote_disappear();
+	memcpy(&r, head, sizeof(r));
+	comm_free(head);
+	absorb_deptime(r.deputytime);
+	remote_unpack_read_cache_data(&r);
+	return(r.ret);
+}
+
+void
+mosix_remote_syscall_trace(void)
+{
+	struct rusage r;
+
+	remote_fill_rusage(&r, 0);
+	if(remote_request(REM_SYSCALL_TRACE, &r, sizeof(r), NULL, 0, 0,
+								NULL, 0))
+		remote_disappear();
+	bump_syscalls();	/* no accurate numbers, but it costs! */
+	wait_for_permission_to_continue();
+}
+
+int
+remote_readpage(struct file *fp, struct page *page)
+{
+	int error;
+	char *buffer = kmap(page);
+	struct bring_page_h b;
+	struct page_ret_h r;
+	int dpagein = (current->mosix.dflags & DPAGEIN) ^ DPAGEIN;
+	register struct task_struct *p = current;
+
+	if(!PageLocked(page))
+		PAGE_BUG(page);
+	b.fp = home_file(fp);
+	b.offset = page->index << PAGE_CACHE_SHIFT;
+	b.nopage = fp->f_dentry->d_inode->u.remote_i.nopage;
+	if(p->mosix.rfreepages > 0)
+		p->mosix.rfreepages--;
+	else
+		bump_demandpages();
+	if(p->mosix.rpagecredit > 0)
+		p->mosix.rpagecredit--;
+	else
+	{
+		spin_lock_irq(&runqueue_lock);
+		p->mosix.dflags |= dpagein;
+		spin_unlock_irq(&runqueue_lock);
+	}
+	if(!b.nopage)	/* home rebooted, we should be dead anyway */
+		error = -EIO;
+	else if(!(error = remote_request(REM_PAGE, &b, sizeof(b), NULL, 0, 0,
+		(void **)&r, -sizeof(r))))
+		error = r.ret;
+	if(!error)
+		error = comm_copydata(buffer, PAGE_SIZE, 0);
+	else if(error == -EFBIG)
+	{
+		memset(buffer, 0, PAGE_SIZE);
+		error = 0;
+	}
+	if(error)
+	{
+		ClearPageUptodate(page);
+		SetPageError(page);
+	}
+	else
+		SetPageUptodate(page);
+	UnlockPage(page);
+	kunmap(page);
+	spin_lock_irq(&runqueue_lock);
+	p->mosix.dflags &= ~dpagein;
+	spin_unlock_irq(&runqueue_lock);
+	absorb_deptime(r.deputytime);
+	return(error);
+}
+
+u64
+mosix_remote_tsc(void)
+{
+	u64 r;
+
+	if(remote_request(REM_GETTSC, NULL, 0, NULL, 0, 0,
+						(void **)&r, -sizeof(r)))
+		force_sig(SIGSEGV, current);
+	bump_syscalls();
+	return(r);
+}
+
+int
+remote_setup_frame(struct setupframe_parameters_h *s)
+{
+	struct k_sigaction ka;
+	extern void setup_frame(int, struct k_sigaction *,
+						sigset_t *, struct pt_regs *);
+	extern void setup_rt_frame(int, struct k_sigaction *, siginfo_t *,
+						sigset_t *, struct pt_regs *);
+
+	ka.sa.sa_flags = s->flags;
+	ka.sa.sa_handler = s->handler;
+	ka.sa.sa_restorer = s->restorer;
+	current->sas_ss_sp = s->ss_sp;
+	current->sas_ss_size = s->ss_size;
+	if(s->flags & SA_SIGINFO)
+		setup_rt_frame(s->sig, &ka, &s->info, &s->set, mos_to_regs(&current->mosix));
+	else
+		setup_frame(s->sig, &ka, &s->set, mos_to_regs(&current->mosix));
+	comm_free(s);
+	return(comm_send(DEP_SETUPFRAME|REPLY, NULL, 0, NULL, 0, 0));
+}
+
+int
+remote_nice(long *n)
+{
+	current->nice = *n;
+	comm_free(n);
+	return(comm_send(DEP_NICE|REPLY, NULL, 0, NULL, 0, 0));
+}
+
+void
+remote_do_updinfo(struct disclosure_h *info)
+{
+	unsigned int i, j;
+	struct task_struct *p = current;
+
+	p->mosix.disclosure = info->disclosure;
+	p->uid = info->uid;
+	p->gid = info->gid;
+	p->mosix.depinfo.pgrp = info->pgrp;
+	p->mosix.depinfo.session = info->session;
+	p->mosix.depinfo.tgid = info->tgid; 
+	for(i = j = 0 ; j < 16 ; i++)
+		switch(info->comm[i])
+		{
+		case '\0':
+			p->mosix.depinfo.comm[j] = '\0';
+			return;
+		case '\n':
+			if(j == 15)
+				p->mosix.depinfo.comm[j] = '\0';
+			p->mosix.depinfo.comm[j++] = '\\';
+			p->mosix.depinfo.comm[j++] = 'n';
+			break;
+		default:
+			p->mosix.depinfo.comm[j++] = info->comm[i];
+		}
+}
+
+int
+remote_updinfo(struct disclosure_h *info)
+{
+	remote_do_updinfo(info);
+	comm_free(info);
+	return(comm_send(DEP_INFO|REPLY, NULL, 0, NULL, 0, 0));
+}
+
+int
+remote_caps(kernel_cap_t *caps)
+{
+	kernel_cap_t effective = *caps & REMOTE_CAPS;
+
+	comm_free(caps);
+	current->cap_effective &= ~REMOTE_CAPS;
+	current->cap_effective |= effective;
+	return(comm_send(DEP_CAPS|REPLY, NULL, 0, NULL, 0, 0));
+}
+
+int
+remote_depcosts(void *info)
+{
+	memcpy((caddr_t)current->mosix.depcost, info,
+		sizeof(current->mosix.depcost));
+	comm_free(info);
+	return(comm_send(DEP_OPCOSTS|REPLY, NULL, 0, NULL, 0, 0));
+}
+
+int
+remote_restore_sigcontext(struct sigcontext **frame)
+{
+	extern int restore_sigcontext(struct pt_regs *, struct sigcontext *,
+									int *);
+	struct restore_sigcontext_ret_h r;
+
+	r.result = restore_sigcontext(mos_to_regs(&current->mosix), *frame,
+									&r.eax);
+
+	comm_free(frame);
+	current->mosix.pass_regs |= BIT_OF_REGISTER(esp);
+	return(comm_send(DEP_RESTORESIGCONTEXT|REPLY, &r, sizeof(r),
+								NULL, 0, 0));
+}
+
+/*
+ * the following routine, if called within process-migration,
+ * returns the fact of an error, rather than sends back a reply:
+ */
+int
+remote_mmap(struct mmap_parameters_h *m, int inmig)
+{
+	unsigned long result;
+	struct file *rf;
+	unsigned long prot, flags;
+	extern asmlinkage long sys_madvise(unsigned long, size_t, int);
+
+	if(m->fp)
+	{
+		if(!(rf = get_remote_file(m->origin, m->fp, m->dp, m->uniq,
+							m->isize, m->nopage)))
+		{
+			result = -EDOITATHOME;
+			goto err;
+		}
+	}
+	else
+		rf = NULL;
+	/* unconvert prot+flags: */
+	prot = 0;
+	flags = MAP_PRIVATE;
+	if(m->fixed)
+		flags |= MAP_FIXED;
+	if(m->flags & VM_GROWSDOWN)
+		flags |= MAP_GROWSDOWN;
+	if(m->flags & VM_DENYWRITE)
+		flags |= MAP_DENYWRITE;
+	if(m->flags & VM_EXECUTABLE)
+		flags |= MAP_EXECUTABLE;
+	if(m->flags & VM_READ)
+		prot |= VM_READ;
+	if(m->flags & VM_WRITE)
+		prot |= VM_WRITE;
+	if(m->flags & VM_EXEC)
+		prot |= VM_EXEC;
+	if(m->flags & VM_MAYSHARE)
+		current->mosix.dirty_bits |= MMAP_MAYSHARE;
+	result = do_mmap_pgoff(rf, m->addr, m->len, prot, flags, m->pgoff);
+	if(m->flags & VM_MAYSHARE)
+		current->mosix.dirty_bits &= ~MMAP_MAYSHARE;
+	if(rf && !IS_ERR((const void *)result))
+	{
+		int pages = (m->len + PAGE_SIZE - 1) / PAGE_SIZE;
+
+		current->mosix.rpagecredit += pages;
+		if(current->mosix.dflags & DINCOMING)
+			current->mosix.rfreepages += pages;
+	}
+	if(m->flags & VM_READHINTMASK)
+		sys_madvise(m->addr, m->len, (m->flags & VM_SEQ_READ) ?
+						MADV_RANDOM : MADV_SEQUENTIAL);
+	err:
+	if(rf)
+		fput(rf);
+	if(inmig)
+		return(IS_ERR((const void *)result));
+	comm_free(m);
+	return(comm_send(DEP_MMAP|REPLY, &result, sizeof(result), NULL, 0, 0));
+}
+
+int
+remote_brk(struct brk_parameters_h *b)
+{
+	long result = do_brk(b->addr, b->len);
+
+	comm_free(b);
+	return(comm_send(DEP_BRK|REPLY, &result, sizeof(result), NULL, 0, 0));
+}
+
+int
+remote_munmap(struct munmap_parameters_h *m)
+{
+	int result = do_munmap(current->mm, m->addr, m->len);
+
+	comm_free(m);
+	return(comm_send(DEP_MUNMAP|REPLY, &result, sizeof(result), NULL, 0, 0));
+}
+
+int
+remote_mprotect(struct mprotect_parameters_h *m)
+{
+	extern asmlinkage int sys_mprotect(unsigned long,size_t,unsigned long);
+	int result = sys_mprotect(m->addr, m->len, m->prot);
+
+	comm_free(m);
+	return(comm_send(DEP_MPROTECT|REPLY, &result, sizeof(result), NULL, 0, 0));
+}
+
+int
+remote_copy_from_user(struct user_copy_h *u)
+{
+	int result;
+	void *to;
+	int direct = ucache_ok((unsigned long)u->addr, (unsigned long)u->size,
+								VM_READ);
+
+	if(direct)
+	{
+		result = 0;
+		to = u->addr;
+	}
+	else
+	{
+		if(!(to = kmalloc(u->size, GFP_KERNEL)))
+			result = u->size;
+		else if(u->verify)
+			result = copy_from_user(to, u->addr, u->size);
+		else
+			result = __copy_from_user(to, u->addr, u->size);
+	}
+	result = comm_send(DEP_COPY_FROM_USER|REPLY, &result, sizeof(result),
+		(result == u->size) ? NULL : to, u->size - result, direct);
+	bump_copyin(u->size);
+	comm_free(u);
+	if(!direct && to)
+		kfree(to);
+	return(result);
+}
+
+int
+remote_copy_to_user(struct user_copy_h *u)
+{
+	int result;
+
+	if(u->verify && !access_ok(VERIFY_WRITE, u->addr, u->size))
+		result = u->size;
+	else
+	{
+		result = comm_copydata(u->addr, u->size, 1);
+		if(result < 0)
+			result = u->size;
+	}
+	if(result)
+		comm_flushdata(COMM_ALLDATA);
+	bump_copyout(u->size);
+	comm_free(u);
+	return(comm_send(DEP_COPY_TO_USER|REPLY, &result, sizeof(result),
+		NULL, 0, 0));
+}
+
+int
+remote_data_to_user(struct user_copy_h *u)
+{
+	int error = (comm_copydata(u->addr, u->size, 1) != 0);
+
+	bump_copyout(u->size);
+	comm_free(u);
+	if(error)
+		comm_flushdata(COMM_ALLDATA);
+	/* No Reply! */
+	return(error);
+}
+
+int
+remote_clear_user(struct user_copy_h *u)
+{
+	int result = u->verify ? clear_user(u->addr, u->size) :
+				__clear_user(u->addr, u->size);
+
+	comm_free(u);
+	return(comm_send(DEP_CLEAR_USER|REPLY, &result, sizeof(result),
+		NULL, 0, 0));
+}
+
+int
+remote_strncpy_from_user(struct user_copy_h *u)
+{
+	int result;
+	void *to = kmalloc(u->size, GFP_KERNEL);
+
+	if(!to)
+		result = -ENOMEM;
+	else if(u->verify)
+		result = strncpy_from_user(to, u->addr, u->size);
+	else
+		result = __strncpy_from_user(to, u->addr, u->size);
+	comm_free(u);
+	result = comm_send(DEP_STRNCPY_FROM_USER|REPLY, &result, sizeof(result),
+		result > 0 ? to : NULL, result > 0 ? result : 0, 0);
+	if(to)
+		kfree(to);
+	if(result > 0)
+		bump_copyin(result);
+	return(result);
+}
+
+int
+remote_strnlen_user(struct strnlen_user_h *u)
+{
+	long result;
+	char c;
+
+	if(u->len)
+		result = strnlen_user(u->addr, u->len);
+	else  /* "strnlen_user" does not handle "0 bytes remaining" correctly */
+		result = !copy_from_user(&c, u->addr, 1);
+	comm_free(u);
+	return(comm_send(DEP_STRNLEN_USER|REPLY, &result, sizeof(result),
+		NULL, 0, 0));
+}
+
+int
+remote_verify_write(struct user_copy_h *u)
+{
+	int result = __verify_write(u->addr, u->size);
+
+	comm_free(u);
+	return(comm_send(DEP_VERIFY_WRITE|REPLY, &result, sizeof(result),
+		NULL, 0, 0));
+}
+
+int
+remote_csum_copy_from_user(struct user_csum_copy_h *u)
+{
+	struct user_csum_copy_ret_h r;
+	void *to = kmalloc(u->len, GFP_KERNEL);
+	int result;
+
+	r.error = 0;
+	if(!to)
+		r.error = -ENOMEM;
+	else
+		r.newsum = csum_partial_copy_from_user(u->addr, to, u->len,
+			u->sum, &r.error);
+	result = comm_send(DEP_CSUM_COPY_FROM_USER|REPLY, &r, sizeof(r),
+		r.error ? NULL : to, r.error ? 0 : u->len, 0);
+	bump_copyin(u->len);
+	comm_free(u);
+	if(to)
+		kfree(to);
+	return(result);
+}
+
+int
+remote_rlimit(struct rlimit_h *l)
+{
+	current->rlim[l->resource] = l->limit;
+	comm_free(l);
+	return(comm_send(DEP_RLIMIT|REPLY, NULL, 0, NULL, 0, 0));
+}
+
+int
+remote_urgent(void)
+{
+	register struct task_struct *p = current;
+	int w;
+
+	spin_lock_irq(&runqueue_lock);
+	p->mosix.dflags &= ~DSENTURGENT;
+	spin_unlock_irq(&runqueue_lock);
+	spin_lock_irq(&whereto_lock);
+	w = p->mosix.whereto;
+	p->mosix.whereto = 0;
+	spin_unlock_irq(&whereto_lock);
+#ifdef CONFIG_MOSIX_DFSA
+	if(process_told(p, DREQ_DFSASYNC))
+	{
+		remote_clear_dfsa();
+		clear_dfsasync();
+	}
+#endif /* CONFIG_MOSIX_DFSA */
+	return(comm_send(DEP_TAKEURGENT|REPLY, &w, sizeof(w), NULL, 0, 0));
+}
+
+int
+remote_rusage(int *finalp)
+{
+	struct rusage r;
+
+	/* "*finalp" just means that calculation of "exit_mem" is required */
+	remote_fill_rusage(&r, *finalp);
+	comm_free(finalp);
+	return(comm_send(DEP_RUSAGE|REPLY, &r, sizeof(r), NULL, 0, 0));
+}
+
+void
+remote_fill_rusage(struct rusage *r, int final)
+{
+	register struct task_struct *p = current;
+	struct vm_area_struct *vma;
+	clock_t ut, st;
+
+	cli();
+	ut = p->times.tms_utime;
+	st = p->times.tms_stime;
+	p->times.tms_utime = 0;
+	p->times.tms_stime = 0;
+	sti();
+	r->ru_utime.tv_sec = CT_TO_SECS(ut);
+	r->ru_utime.tv_usec = CT_TO_USECS(ut);
+	p->mosix.passedtime += ut;
+	p->mosix.uttime += ut;
+	r->ru_stime.tv_sec = CT_TO_SECS(st);
+	r->ru_stime.tv_usec = CT_TO_USECS(st);
+	p->mosix.passedtime += st;
+	r->ru_minflt = p->min_flt;
+	p->min_flt = 0;
+	r->ru_majflt = p->maj_flt;
+	p->maj_flt = 0;
+	r->ru_nswap = p->nswap;
+	p->nswap = 0;
+	if(final)
+	{
+		r->ru_maxrss = 0;
+		if (current->mm)
+		for(vma = current->mm->mmap ; vma ; vma = vma->vm_next)
+			r->ru_maxrss += vma->vm_end - vma->vm_start;
+	}
+}
+
+int
+remote_execve_counts(struct execve_counts_h *e)
+{
+	struct execve_counts_ret_h r;
+
+	execve_remote_counts(e->argp, e->envp, &r.argc, &r.envc);
+	comm_free(e);
+	return(comm_send(DEP_EXECVE_COUNTS|REPLY, &r, sizeof(r), NULL, 0, 0));
+}
+
+int
+remote_bring_strings(struct execve_bring_strings_h *b)
+{
+	struct linux_binprm bprm;
+	struct execve_bring_strings_ret_h r;
+	struct execve_more_strings_h m;
+	unsigned int i;
+	int err = 0;
+	char *kaddr;
+
+	bprm.p = b->p;
+	bprm.filename = b->filename;
+	bprm.envc = b->envc;
+	bprm.argc = b->argc;
+	memset(bprm.page, 0, MAX_ARG_PAGES * sizeof(bprm.page[0]));
+	current->mosix.inexec = &bprm;
+	r.result = execve_remote_bring_strings(&bprm, b->envp, b->argp);
+	r.p = bprm.p;
+	r.exec = bprm.exec;
+	comm_free(b);
+	if(r.result == 0)
+	{
+		for(i = r.p / PAGE_SIZE ; i < MAX_ARG_PAGES - 1 ; i++)
+		if(bprm.page[i])
+		{
+			m.pgno = i + 1;
+			m.len = (i + 1) * PAGE_SIZE - r.p;
+			if(m.len > PAGE_SIZE)
+				m.len = PAGE_SIZE;
+			if(!err)
+			{
+				kaddr = kmap(bprm.page[i]);
+				err = comm_send(REM_MORESTRINGS, &m, sizeof(m),
+				      kaddr + (PAGE_SIZE - m.len), m.len, 0);
+				kunmap(bprm.page[i]);
+			}
+			__free_page(bprm.page[i]);
+			bprm.page[i] = 0;
+		}
+	}
+	if(!err)
+	{
+		if(r.result == 0 && bprm.page[MAX_ARG_PAGES-1])
+		{
+			r.pgno = MAX_ARG_PAGES;
+			r.len = MAX_ARG_PAGES * PAGE_SIZE - r.p;
+			if(r.len > PAGE_SIZE)
+				r.len = PAGE_SIZE;
+			kaddr = kmap(bprm.page[MAX_ARG_PAGES-1]);
+		}
+		else
+		{
+			r.pgno = 0;
+			kaddr = NULL;	/* only to pacify the compiler */
+		}
+		err = comm_send(DEP_BRING_STRINGS|REPLY, &r, sizeof(r), r.pgno ?
+			(kaddr + (PAGE_SIZE-r.len)) : 0, r.pgno ? r.len : 0, 0);
+		if(r.pgno)
+			kunmap(bprm.page[MAX_ARG_PAGES-1]);
+	}
+	for(i = 0 ; i < MAX_ARG_PAGES ; i++)
+	if(bprm.page[i])
+		__free_page(bprm.page[i]);
+	current->mosix.inexec = NULL;
+	return(err);
+}
+
+int
+remote_setup_args(struct execve_setup_args_h *e)
+{
+	int i;
+	struct task_struct *p = current;
+	register struct linux_binprm *bprm = p->mosix.inexec;
+	struct execve_setup_args_ret_h r;
+	int err = 0;
+	struct page *page;
+	char *kaddr;
+
+	if(e->create)
+	{
+		if((bprm = p->mosix.inexec = kmalloc(sizeof(*bprm),GFP_KERNEL)))
+			memset(bprm->page, 0,
+					MAX_ARG_PAGES * sizeof(bprm->page[0]));
+	}
+	if(bprm && e->pgno)
+	{
+		if(!(page = alloc_page(GFP_HIGHUSER)))
+		{
+			comm_flushdata(e->len);
+			goto fail;
+		}
+		bprm->page[e->pgno-1] = page;
+		kaddr = kmap(page);
+		i = comm_copydata(kaddr + (PAGE_SIZE - e->len), e->len, 0);
+		if(e->len < PAGE_SIZE)
+			memset(kaddr, 0, PAGE_SIZE - e->len);
+		kunmap(page);
+		if(i)
+		{
+			fail:
+			for(i = 0 ; i < MAX_ARG_PAGES ; i++)
+			if(bprm->page[i])
+				__free_page(bprm->page[i]);
+			kfree(bprm);
+			bprm = p->mosix.inexec = NULL;
+		}
+	}
+	else if(e->pgno)
+		comm_flushdata(e->len);
+	if(e->how == SETUP_ARGS_NOTYET)
+		goto out;
+	if(!p->mosix.inexec)	/* one of the allocations failed */
+		r.reply = -ENOMEM;
+	else
+	{
+		if(e->how == SETUP_ARGS_AS_ELF)
+		{
+			p->mm->start_data = 0;
+			p->mm->end_data = 0;
+			p->mm->end_code = 0;
+			p->mm->rss = 0;
+			p->mm->mmap = NULL;
+		}
+		bprm->p = e->p;
+		bprm->loader = e->loader;
+		bprm->exec = e->exec;
+		bprm->argc = e->argc;
+		bprm->envc = e->envc;
+		p->personality = e->personality;
+		r.reply = setup_arg_pages(bprm);
+		if(e->how == SETUP_ARGS_AS_AOUT)
+		{
+			if(r.reply == 0)
+				p->mm->start_stack = (unsigned long)
+				create_aout_tables((char *)bprm->p, bprm);
+		}
+		else
+			p->mm->start_stack = bprm->p;
+		r.p = bprm->p;
+		r.loader = bprm->loader;
+		r.exec = bprm->exec;
+		if(r.reply == 0)
+			p->ptrace &= ~PT_DTRACE;
+		r.start_stack = p->mm->start_stack;
+	}
+	p->mosix.pass_regs |= BIT_OF_REGISTER(xds)|BIT_OF_REGISTER(xes)|
+		BIT_OF_REGISTER(xss)|BIT_OF_REGISTER(xcs)|BIT_OF_REGISTER(eip)|
+		BIT_OF_REGISTER(esp);
+	err = comm_send(DEP_SETUP_ARGS|REPLY, &r, sizeof(r), NULL, 0, 0);
+	mosix_decay_exec();
+	out:
+	if(e->how != SETUP_ARGS_NOTYET && bprm)
+	{
+		kfree(bprm);
+		p->mosix.inexec = NULL;
+	}
+	comm_free(e);
+	return(err);
+}
+
+int
+remote_exec_mmap(void)
+{
+	int r;
+
+	if(!(r = exec_mmap()))
+	{
+		flush_thread();
+		mosix_clear_statistics();
+		current->mosix.rpagecredit = 0;
+		current->mosix.rfreepages = 0;
+		current->sas_ss_sp = current->sas_ss_size = 0;
+	}
+	return(comm_send(DEP_EXEC_MMAP|REPLY, &r, sizeof(r), NULL, 0, 0));
+}
+
+int
+remote_dump_thread(void)
+{
+	extern void dump_thread(struct pt_regs *, struct user *);
+	struct user u;
+	/* (size == 286 bytes -- should be OK while allocation can fail) */
+
+	dump_thread(mos_to_regs(&current->mosix), &u);
+	return(comm_send(DEP_DUMP_THREAD|REPLY, &u, sizeof(u), NULL, 0, 0));
+}
+
+int
+remote_init_aout_mm(struct exec *ex)
+{
+	aout_remote_init_mm(ex);
+	comm_free(ex);
+	return(comm_send(DEP_INIT_AOUT_MM|REPLY, NULL, 0, NULL, 0, 0));
+}
+
+int
+remote_elf_setup(struct execve_elf_setup_h *e)
+{
+	unsigned long r;
+	struct elfhdr h;
+
+	h.e_phoff = e->exec_e_phoff;
+	h.e_phnum = e->exec_e_phnum;
+	h.e_entry = e->exec_e_entry;
+	r = elf_remote_setup(e->p, e->argc, e->envc, e->hasexec ? &h : NULL,
+		e->addr, e->load_bias, e->interp_load_addr, e->ibcs,
+		e->add_arg_start, e->elf_brk, e->end_code,
+		e->start_code, e->start_data, e->end_data, e->elf_bss,
+		e->personality, &e->extras);
+	comm_free(e);
+	return(comm_send(DEP_ELF_SETUP|REPLY, &r, sizeof(r), NULL, 0, 0));
+}
+
+int
+remote_fix_elf_aout(struct execve_fix_elf_aout_h *f)
+{
+	current->mm->brk = f->bss +
+		(current->mm->end_data = f->data +
+			(current->mm->end_code = f->text));
+	comm_free(f);
+	return(comm_send(DEP_FIX_ELF_AOUT|REPLY, NULL, 0, NULL, 0, 0));
+}
+
+int
+remote_list_vmas(void)
+{
+	register int i;
+	register struct vm_area_struct *vma;
+	struct mm_struct *mm = current->mm;
+	struct vmalist *lis = NULL;
+	struct list_vmas_ret_h r;
+	int error;
+
+	if(!mm)
+		mosix_panic("remote_list_vmas: no mm");
+	r.argstart = current->mm->arg_start;
+	r.argend = current->mm->arg_end;
+	for(i = 0 , vma = mm->mmap ; vma ; vma = vma->vm_next)
+		i++;
+	if(i && !(lis = kmalloc(i * sizeof(struct vmalist), GFP_KERNEL)))
+		i = -1;
+	if((r.n = i) <= 0)
+		return(comm_send(DEP_LIST_VMAS|REPLY, &r, sizeof(r), NULL,0,0));
+	for(i = 0 , vma = mm->mmap ; vma && i < r.n ; vma = vma->vm_next , i++)
+	{
+		lis[i].vmstart = vma->vm_start;
+		lis[i].vmend = vma->vm_end;
+		lis[i].vmflags = vma->vm_flags;
+		lis[i].maydump = elf_maydump(vma);
+	}
+	error = comm_send(DEP_LIST_VMAS|REPLY, &r, sizeof(r),
+		lis, i * sizeof(struct vmalist), 0);
+	kfree(lis);
+	return(error);
+}
+
+int
+remote_fork(struct fork_h *f)
+{
+	struct mosix_task *me = &current->mosix;
+	struct fork_h lf = *f;
+	mosix_addr a;
+	mosix_link *sonsock;
+	int pid;
+	register struct task_struct *son;
+	int err;
+	unsigned int tries;
+	int done, ret;
+
+	comm_free(f);
+	mosix_obtain_registers(ALL_REGISTERS & ~BIT_OF_REGISTER(eax));
+	if(lf.do_forkmigrate)
+		mosix_forkmigrate();	/* may not return */
+	ret = -EAGAIN;
+	for(tries = 0 ; ; tries++)
+	{
+		if(tries >= 100 || !(sonsock =
+				comm_open(COMM_ACCEPT, &a, comm_remote_timo)))
+			goto out;
+		if((err = remote_request(REM_CONNECT_TO, &a, sizeof(a),
+				NULL, 0, 0, (void **)&done, -sizeof(done))))
+		{
+			comm_close(sonsock);
+			return(err);
+		}
+		if(done)
+			break;
+		comm_close(sonsock);
+	}
+	me->sonpid = lf.pid;
+	me->sontgid = lf.tgid;
+	if((pid = do_fork(SIGCHLD|CLONE_SIGHAND
+#ifndef CONFIG_MOSIX_DFSA
+		|CLONE_FS|CLONE_FILES
+#endif /* CONFIG_MOSIX_DFSA */
+		, lf.usp, mos_to_regs(me), 0)) < 0)
+	{
+		comm_close(sonsock);
+		goto out;
+	}
+	read_lock(&tasklist_lock);
+	for_each_task(son)
+	if(son->pid == pid)
+		break;
+	read_unlock(&tasklist_lock);
+	comm_use(son, sonsock);
+	wake_up(mos_to_waitp(&son->mosix));
+	ret = 0;
+	out:
+	return(comm_send(DEP_PLEASE_FORK|REPLY, &ret, sizeof(ret), NULL, 0, 0));
+}
+
+int
+remote_personality(unsigned long *pp)
+{
+	int res;
+	unsigned long personality = *pp;
+
+	comm_free(pp);
+	set_personality(personality);
+	res = (current->personality == personality) ? 0 : -1;
+	return(comm_send(DEP_PERSONALITY|REPLY, &res, sizeof(res), NULL, 0, 0));
+}
+
+int
+remote_bring_me_regs(unsigned long *bring)
+{
+	struct mosix_task *m = &current->mosix;
+
+	m->pass_regs |= *bring & ~m->deputy_regs;
+	comm_free(bring);
+	return(comm_send(DEP_BRING_ME_REGS|REPLY, NULL, 0, NULL, 0, 0));
+}
+
+int
+remote_dump_fpu(void)
+{
+	extern int dump_fpu (struct pt_regs *, struct user_i387_struct *);
+	struct user_i387_struct f;
+	int r = dump_fpu(mos_to_regs(&current->mosix), &f);
+
+	return(comm_send(DEP_DUMP_FPU|REPLY, &r, sizeof(r),
+		r ? &f : NULL, r ? sizeof(f) : 0, 0));
+}
+
+int
+remote_come_back(void *head)
+{
+	struct mosix_task *m = &current->mosix;
+	int reason = *((int *) head);
+	int reply;
+	int omigpages;
+
+	comm_free(head);
+	if(!(omigpages = current->mosix.migpages))
+		m->migpages = count_migrating_pages();
+	if (mig_send_request(reason, FROM_REMOTE))
+	{
+		m->migpages = omigpages;
+		return (-EDIST);
+	}
+	spin_lock_irq(&runqueue_lock);
+	m->dflags |= DPASSING;
+	spin_unlock_irq(&runqueue_lock);
+	
+	release_migrations(m->deppe);
+	reply = mig_do_send();
+	m->migpages = omigpages;
+	spin_lock_irq(&runqueue_lock);
+	m->dflags &= ~DPASSING;
+	spin_unlock_irq(&runqueue_lock);
+	return(reply);
+}
+
+int
+remote_goto_remote(void *head)
+{
+	struct task_struct *p = current;
+	mosix_link *remsock = NULL;
+	mosix_link *depsock;
+	struct please_migrate_h *pm = (struct please_migrate_h *)head;
+	int reason = pm->reason;
+	int status = 1;
+	int error;
+	int whereto = pm->to;
+	int omigpages;
+
+	spin_lock_irq(&runqueue_lock);
+	p->mosix.dflags |= DPASSING;
+	spin_unlock_irq(&runqueue_lock);
+	remsock = comm_open(COMM_TOADDR, &pm->ma, comm_reconn_timo);
+	comm_free(head);
+	if (!remsock)
+		goto reply;
+
+	depsock = comm_use(p, remsock);
+	if(!(omigpages = p->mosix.migpages))
+		current->mosix.migpages = count_migrating_pages();
+	if ((error = mig_send_request(reason, FROM_REMOTE)))
+		goto cont;
+
+	release_migrations(whereto);
+	if (!mig_do_send())
+		status = 0;
+cont:
+	p->mosix.migpages = omigpages;
+	comm_use(p, depsock);
+	comm_close(remsock);
+
+reply:
+	error = comm_send(DEP_PLEASE_MIGRATE | REPLY, (void *)&status,
+						sizeof(status), NULL, 0, 0);
+	if (!(status || error))
+		remote_disappear();
+	spin_lock_irq(&runqueue_lock);
+	p->mosix.dflags &= ~DPASSING;
+	spin_unlock_irq(&runqueue_lock);
+	return (error);
+}
+
+int
+remote_consider(int *reasonp)
+{
+	int reason = *reasonp;
+
+	comm_free(reasonp);
+	consider(reason, NULL);
+	return(0);
+}
+
+int
+remote_psinfo(void)
+{
+	int n;
+	char *p = fill_common_ps_info(&n);
+	int err;
+
+	if(!p)
+		return(comm_send(DEP_PSINFO|REPLY, &n, sizeof(n), NULL, 0, 0));
+	err = comm_send(DEP_PSINFO|REPLY, &n, sizeof(n), p, n, 0);
+	kfree(p);
+	return(err);
+}
+
+#ifdef CONFIG_MOSIX_DFSA
+int
+remote_receive_dfsachanges(int *head)
+{
+	int len = *head;
+	char *changes;
+	int error = 0;
+
+	comm_free(head);
+	if((changes = kmalloc(len, GFP_KERNEL)))
+	{
+		if((error = comm_copydata(changes, len, 0)))
+		{
+			remote_clear_dfsa();
+			kfree(changes);
+		}
+		else
+			remote_unpack_dfsa_changes(changes);
+	}
+	else
+		remote_clear_dfsa();
+	
+	if(!error)
+		error = comm_send(DEP_DFSA_CHANGES|REPLY, NULL, 0, NULL, 0, 0);
+	return(error);
+}
+#endif /* CONFIG_MOSIX_DFSA */
+
+void
+absorb_deptime(unsigned long ticks)
+{
+	register struct task_struct *p = current;
+	unsigned long it_prof = p->it_prof_value;
+
+	if(it_prof)
+	{
+		cli();
+		if(it_prof > ticks)
+		{
+			p->it_prof_value -= ticks;
+			sti();
+		}
+		else
+		{
+			p->it_prof_value = p->it_prof_incr;
+			sti();
+			send_sig(SIGPROF, p, 1);
+		}
+	}
+}
